image: clojure:openjdk-13-lein-slim-buster

variables:
  # Required to avoid escaping issues
  CLOJARS_PASSWORD: '$CLOJARS_PASS'

before_script:
  # Leiningen settings
  - mkdir -p ~/.lein
  - 'echo "{:user {:local-repo \"$CI_PROJECT_DIR/repo\"} :auth {:repository-auth {{#\"clojars\" {:username \"$CLOJARS_USER\" :password \"$CLOJARS_PASSWORD\"}}}}" > ~/.lein/profiles.clj'

clj:test:
  stage: test
  script:
    - lein midje :config midje-gitlab.clj
  artifacts:
    reports:
      junit: target/surefire-reports/*.xml
  cache:
    key:
      files:
        - project.clj
    paths:
      - $CI_PROJECT_DIR/repo
    policy: pull-push

clj:publish:
  stage: publish
  script:
    - lein deploy dn-clojars
  cache:
    key:
      files:
        - project.clj
    paths:
      - $CI_PROJECT_DIR/repo
    policy: pull
  dependencies:
    - clj:test
  rules:
    # Deploy if the branch is master or a release tag
    - if: '$CI_COMMIT_BRANCH == "master" || $CI_COMMIT_TAG  =~ /^release/'
      when: on_success

stages:
  - test
  - publish
